RDKit: RDKit::MolShapes Namespace Reference

| RDKit Open-source cheminformatics and machine learning.

Loading...
Searching...
No Matches
Functions
RDKit::MolShapes Namespace Reference

## Functions
RDKIT_SHAPEHELPERS_EXPORT void | EncodeShape (const ROMol &mol, RDGeom::UniformGrid3D &grid, int confId=-1, const RDGeom::Transform3D *trans=nullptr, double vdwScale=0.8, double stepSize=0.25, int maxLayers=-1, bool ignoreHs=true)
| Encode the shape of a molecule on to a grid.
RDKIT_SHAPEHELPERS_EXPORT void | EncodeShape (const Conformer &conf, RDGeom::UniformGrid3D &grid, const RDGeom::Transform3D *trans=nullptr, double vdwScale=0.8, double stepSize=0.25, int maxLayers=-1, bool ignoreHs=true)
| Emcode the shape of a conformer on to a grid.
RDKIT_SHAPEHELPERS_EXPORT void | computeConfDimsAndOffset (const Conformer &conf, RDGeom::Point3D &dims, RDGeom::Point3D &offSet, const RDGeom::Transform3D *trans=nullptr, double padding=2.5)
RDKIT_SHAPEHELPERS_EXPORT void | computeConfBox (const Conformer &conf, RDGeom::Point3D &leftBottom, RDGeom::Point3D &rightTop, const RDGeom::Transform3D *trans=nullptr, double padding=2.5)
| Compute the box that will fit the conformer.
RDKIT_SHAPEHELPERS_EXPORT void | computeUnionBox (const RDGeom::Point3D &leftBottom1, const RDGeom::Point3D &rightTop1, const RDGeom::Point3D &leftBottom2, const RDGeom::Point3D &rightTop2, RDGeom::Point3D &uLeftBottom, RDGeom::Point3D &uRightTop)
| Compute the union of two boxes.
RDKIT_SHAPEHELPERS_EXPORT std::vector< double > | getConfDimensions (const Conformer &conf, double padding=2.5, const RDGeom::Point3D *center=nullptr, bool ignoreHs=true)
| Compute dimensions of a conformer.
RDKIT_SHAPEHELPERS_EXPORT double | tverskyIndex (const ROMol &mol1, const ROMol &mol2, double alpha, double beta, int confId1=-1, int confId2=-1, double gridSpacing=0.5, DiscreteValueVect::DiscreteValueType bitsPerPoint=DiscreteValueVect::TWOBITVALUE, double vdwScale=0.8, double stepSize=0.25, int maxLayers=-1, bool ignoreHs=true)
RDKIT_SHAPEHELPERS_EXPORT double | tverskyIndex (const Conformer &conf1, const Conformer &conf2, double alpha, double beta, double gridSpacing=0.5, DiscreteValueVect::DiscreteValueType bitsPerPoint=DiscreteValueVect::TWOBITVALUE, double vdwScale=0.8, double stepSize=0.25, int maxLayers=-1, bool ignoreHs=true)
RDKIT_SHAPEHELPERS_EXPORT double | tanimotoDistance (const ROMol &mol1, const ROMol &mol2, int confId1=-1, int confId2=-1, double gridSpacing=0.5, DiscreteValueVect::DiscreteValueType bitsPerPoint=DiscreteValueVect::TWOBITVALUE, double vdwScale=0.8, double stepSize=0.25, int maxLayers=-1, bool ignoreHs=true)
RDKIT_SHAPEHELPERS_EXPORT double | tanimotoDistance (const Conformer &conf1, const Conformer &conf2, double gridSpacing=0.5, DiscreteValueVect::DiscreteValueType bitsPerPoint=DiscreteValueVect::TWOBITVALUE, double vdwScale=0.8, double stepSize=0.25, int maxLayers=-1, bool ignoreHs=true)
RDKIT_SHAPEHELPERS_EXPORT double | protrudeDistance (const ROMol &mol1, const ROMol &mol2, int confId1=-1, int confId2=-1, double gridSpacing=0.5, DiscreteValueVect::DiscreteValueType bitsPerPoint=DiscreteValueVect::TWOBITVALUE, double vdwScale=0.8, double stepSize=0.25, int maxLayers=-1, bool ignoreHs=true, bool allowReordering=true)
RDKIT_SHAPEHELPERS_EXPORT double | protrudeDistance (const Conformer &conf1, const Conformer &conf2, double gridSpacing=0.5, DiscreteValueVect::DiscreteValueType bitsPerPoint=DiscreteValueVect::TWOBITVALUE, double vdwScale=0.8, double stepSize=0.25, int maxLayers=-1, bool ignoreHs=true, bool allowReordering=true)

## Function Documentation

## ◆ computeConfBox()

RDKIT_SHAPEHELPERS_EXPORT void RDKit::MolShapes::computeConfBox | ( | const Conformer & | conf,
|  | RDGeom::Point3D & | leftBottom,
|  | RDGeom::Point3D & | rightTop,
|  | const RDGeom::Transform3D * | trans = nullptr,
|  | double | padding = 2.5 )

Compute the box that will fit the conformer.

Parameters

  conf | The conformer of interest
  leftBottom | Storage for one extremity of the box
  rightTop | Storage for other extremity of the box
  trans | Optional transformation to be applied to the atom coordinates
  padding | Padding added on the sides around the conformer

References RDKIT_SHAPEHELPERS_EXPORT.

## ◆ computeConfDimsAndOffset()

RDKIT_SHAPEHELPERS_EXPORT void RDKit::MolShapes::computeConfDimsAndOffset | ( | const Conformer & | conf,
|  | RDGeom::Point3D & | dims,
|  | RDGeom::Point3D & | offSet,
|  | const RDGeom::Transform3D * | trans = nullptr,
|  | double | padding = 2.5 )

Compute the size of the box that can fit the conformation, and offset of the box from the origin

References RDKIT_SHAPEHELPERS_EXPORT.

## ◆ computeUnionBox()

RDKIT_SHAPEHELPERS_EXPORT void RDKit::MolShapes::computeUnionBox | ( | const RDGeom::Point3D & | leftBottom1,
|  | const RDGeom::Point3D & | rightTop1,
|  | const RDGeom::Point3D & | leftBottom2,
|  | const RDGeom::Point3D & | rightTop2,
|  | RDGeom::Point3D & | uLeftBottom,
|  | RDGeom::Point3D & | uRightTop )

Compute the union of two boxes.

References RDKIT_SHAPEHELPERS_EXPORT.

## ◆ EncodeShape() [1/2]

RDKIT_SHAPEHELPERS_EXPORT void RDKit::MolShapes::EncodeShape | ( | const Conformer & | conf,
|  | RDGeom::UniformGrid3D & | grid,
|  | const RDGeom::Transform3D * | trans = nullptr,
|  | double | vdwScale = 0.8,
|  | double | stepSize = 0.25,
|  | int | maxLayers = -1,
|  | bool | ignoreHs = true )

Emcode the shape of a conformer on to a grid.

Parameters

  conf | The conformer of interest
  grid | Grid onto which the molecule is encoded
  trans | Optional 3D transform to be applied to this conformation
  vdwScale | Scaling factor for the radius of the atoms to determine the base radius used in the encoding - grid points inside this sphere carry the maximum occupancy
  stepSize | thickness of the layers outside the base radius, the occupancy value is decreased from layer to layer from the maximum value
  maxLayers | the maximum number of layers - defaults to the number allowed the number of bits use per grid point - e.g. two bits per grid point will allow 3 layers
  ignoreHs | if true, ignore the hydrogen atoms in the shape encoding process

References RDKIT_SHAPEHELPERS_EXPORT.

## ◆ EncodeShape() [2/2]

RDKIT_SHAPEHELPERS_EXPORT void RDKit::MolShapes::EncodeShape | ( | const ROMol & | mol,
|  | RDGeom::UniformGrid3D & | grid,
|  | int | confId = -1,
|  | const RDGeom::Transform3D * | trans = nullptr,
|  | double | vdwScale = 0.8,
|  | double | stepSize = 0.25,
|  | int | maxLayers = -1,
|  | bool | ignoreHs = true )

Encode the shape of a molecule on to a grid.

Parameters

  mol | The molecule of interest
  grid | Grid onto which the molecule is encoded
  confId | Id of the conformation on the molecule to be encoded
  trans | Optional 3D transform to be applied to this conformation
  vdwScale | Scaling factor for the radius of the atoms to determine the base radius used in the encoding - grid points inside this sphere carry the maximum occupancy
  stepSize | thickness of the layers outside the base radius, the occupancy value is decreased from layer to layer from the maximum value
  maxLayers | the maximum number of layers - defaults to the number allowed the number of bits use per grid point - e.g. two bits per grid point will allow 3 layers
  ignoreHs | if true, ignore the hydrogen atoms in the shape encoding process

References RDKIT_SHAPEHELPERS_EXPORT.

## ◆ getConfDimensions()

RDKIT_SHAPEHELPERS_EXPORT std::vector< double > RDKit::MolShapes::getConfDimensions | ( | const Conformer & | conf,
|  | double | padding = 2.5,
|  | const RDGeom::Point3D * | center = nullptr,
|  | bool | ignoreHs = true )

Compute dimensions of a conformer.

Parameters

  conf | Conformer of interest
  padding | Padding added to the atom coordinates on all sides
  center | Optionally specify the center
  ignoreHs | if true, ignore the hydrogen atoms in computing the centroid

References RDKIT_SHAPEHELPERS_EXPORT.

## ◆ protrudeDistance() [1/2]

RDKIT_SHAPEHELPERS_EXPORT double RDKit::MolShapes::protrudeDistance | ( | const Conformer & | conf1,
|  | const Conformer & | conf2,
|  | double | gridSpacing = 0.5,
|  | DiscreteValueVect::DiscreteValueType | bitsPerPoint = DiscreteValueVect::TWOBITVALUE,
|  | double | vdwScale = 0.8,
|  | double | stepSize = 0.25,
|  | int | maxLayers = -1,
|  | bool | ignoreHs = true,
|  | bool | allowReordering = true )

Compute the shape protrusion distance between two conformers based on a predefined alignment

Parameters

  conf1 | The first conformer of interest
  conf2 | The second conformer of interest
  gridSpacing | resolution of the grid used to encode the molecular shapes
  bitsPerPoint | number of bit used to encode the occupancy at each grid point
  vdwScale | Scaling factor for the radius of the atoms to determine the base radius used in the encoding - grid points inside this sphere carry the maximum occupancy
  stepSize | thickness of the each layer outside the base radius, the occupancy value is decreased from layer to layer from the maximum value
  maxLayers | the maximum number of layers - defaults to the number allowed the number of bits use per grid point - e.g. two bits per grid point will allow 3 layers
  ignoreHs | if true, ignore the hydrogen atoms in the shape encoding process
  allowReordering | if set the order will be automatically updated so that the value calculated is the protrusion of the smaller shape from the larger one.

References RDKIT_SHAPEHELPERS_EXPORT, and RDKit::DiscreteValueVect::TWOBITVALUE.

## ◆ protrudeDistance() [2/2]

RDKIT_SHAPEHELPERS_EXPORT double RDKit::MolShapes::protrudeDistance | ( | const ROMol & | mol1,
|  | const ROMol & | mol2,
|  | int | confId1 = -1,
|  | int | confId2 = -1,
|  | double | gridSpacing = 0.5,
|  | DiscreteValueVect::DiscreteValueType | bitsPerPoint = DiscreteValueVect::TWOBITVALUE,
|  | double | vdwScale = 0.8,
|  | double | stepSize = 0.25,
|  | int | maxLayers = -1,
|  | bool | ignoreHs = true,
|  | bool | allowReordering = true )

Compute the shape protrusion distance between two molecule based on a predefined alignment

Parameters

  mol1 | The first molecule of interest
  mol2 | The second molecule of interest
  confId1 | Conformer in the first molecule (defaults to first conformer)
  confId2 | Conformer in the second molecule (defaults to first conformer)
  gridSpacing | resolution of the grid used to encode the molecular shapes
  bitsPerPoint | number of bit used to encode the occupancy at each grid point defaults to two bits per grid point
  vdwScale | Scaling factor for the radius of the atoms to determine the base radius used in the encoding - grid points inside this sphere carry the maximum occupancy
  stepSize | thickness of the each layer outside the base radius, the occupancy value is decreased from layer to layer from the maximum value
  maxLayers | the maximum number of layers - defaults to the number allowed the number of bits use per grid point - e.g. two bits per grid point will allow 3 layers
  ignoreHs | if true, ignore the hydrogen atoms in the shape encoding process
  allowReordering | if set the order will be automatically updated so that the value calculated is the protrusion of the smaller shape from the larger one.

References RDKIT_SHAPEHELPERS_EXPORT, and RDKit::DiscreteValueVect::TWOBITVALUE.

## ◆ tanimotoDistance() [1/2]

RDKIT_SHAPEHELPERS_EXPORT double RDKit::MolShapes::tanimotoDistance | ( | const Conformer & | conf1,
|  | const Conformer & | conf2,
|  | double | gridSpacing = 0.5,
|  | DiscreteValueVect::DiscreteValueType | bitsPerPoint = DiscreteValueVect::TWOBITVALUE,
|  | double | vdwScale = 0.8,
|  | double | stepSize = 0.25,
|  | int | maxLayers = -1,
|  | bool | ignoreHs = true )

Compute the shape tanimoto distance between two conformers based on a predefined alignment

Parameters

  conf1 | The first conformer of interest
  conf2 | The second conformer of interest
  gridSpacing | resolution of the grid used to encode the molecular shapes
  bitsPerPoint | number of bit used to encode the occupancy at each grid point
  vdwScale | Scaling factor for the radius of the atoms to determine the base radius used in the encoding - grid points inside this sphere carry the maximum occupancy
  stepSize | thickness of the each layer outside the base radius, the occupancy value is decreased from layer to layer from the maximum value
  maxLayers | the maximum number of layers - defaults to the number allowed the number of bits use per grid point - e.g. two bits per grid point will allow 3 layers
  ignoreHs | if true, ignore the hydrogen atoms in the shape encoding process

References RDKIT_SHAPEHELPERS_EXPORT, and RDKit::DiscreteValueVect::TWOBITVALUE.

## ◆ tanimotoDistance() [2/2]

RDKIT_SHAPEHELPERS_EXPORT double RDKit::MolShapes::tanimotoDistance | ( | const ROMol & | mol1,
|  | const ROMol & | mol2,
|  | int | confId1 = -1,
|  | int | confId2 = -1,
|  | double | gridSpacing = 0.5,
|  | DiscreteValueVect::DiscreteValueType | bitsPerPoint = DiscreteValueVect::TWOBITVALUE,
|  | double | vdwScale = 0.8,
|  | double | stepSize = 0.25,
|  | int | maxLayers = -1,
|  | bool | ignoreHs = true )

Compute the shape tanimoto distance between two molecule based on a predefined alignment

Parameters

  mol1 | The first molecule of interest
  mol2 | The second molecule of interest
  confId1 | Conformer in the first molecule (defaults to first conformer)
  confId2 | Conformer in the second molecule (defaults to first conformer)
  gridSpacing | resolution of the grid used to encode the molecular shapes
  bitsPerPoint | number of bit used to encode the occupancy at each grid point defaults to two bits per grid point
  vdwScale | Scaling factor for the radius of the atoms to determine the base radius used in the encoding - grid points inside this sphere carry the maximum occupancy
  stepSize | thickness of the each layer outside the base radius, the occupancy value is decreased from layer to layer from the maximum value
  maxLayers | the maximum number of layers - defaults to the number allowed the number of bits use per grid point - e.g. two bits per grid point will allow 3 layers
  ignoreHs | if true, ignore the hydrogen atoms in the shape encoding process

References RDKIT_SHAPEHELPERS_EXPORT, and RDKit::DiscreteValueVect::TWOBITVALUE.

## ◆ tverskyIndex() [1/2]

RDKIT_SHAPEHELPERS_EXPORT double RDKit::MolShapes::tverskyIndex | ( | const Conformer & | conf1,
|  | const Conformer & | conf2,
|  | double | alpha,
|  | double | beta,
|  | double | gridSpacing = 0.5,
|  | DiscreteValueVect::DiscreteValueType | bitsPerPoint = DiscreteValueVect::TWOBITVALUE,
|  | double | vdwScale = 0.8,
|  | double | stepSize = 0.25,
|  | int | maxLayers = -1,
|  | bool | ignoreHs = true )

Compute the shape tversky index between two conformers based on a predefined alignment

Parameters

  conf1 | The first conformer of interest
  conf2 | The second conformer of interest
  alpha |
  beta |
  gridSpacing | resolution of the grid used to encode the molecular shapes
  bitsPerPoint | number of bit used to encode the occupancy at each grid point
  vdwScale | Scaling factor for the radius of the atoms to determine the base radius used in the encoding - grid points inside this sphere carry the maximum occupancy
  stepSize | thickness of the each layer outside the base radius, the occupancy value is decreased from layer to layer from the maximum value
  maxLayers | the maximum number of layers - defaults to the number allowed the number of bits use per grid point - e.g. two bits per grid point will allow 3 layers
  ignoreHs | if true, ignore the hydrogen atoms in the shape encoding process

References RDKIT_SHAPEHELPERS_EXPORT, and RDKit::DiscreteValueVect::TWOBITVALUE.

## ◆ tverskyIndex() [2/2]

RDKIT_SHAPEHELPERS_EXPORT double RDKit::MolShapes::tverskyIndex | ( | const ROMol & | mol1,
|  | const ROMol & | mol2,
|  | double | alpha,
|  | double | beta,
|  | int | confId1 = -1,
|  | int | confId2 = -1,
|  | double | gridSpacing = 0.5,
|  | DiscreteValueVect::DiscreteValueType | bitsPerPoint = DiscreteValueVect::TWOBITVALUE,
|  | double | vdwScale = 0.8,
|  | double | stepSize = 0.25,
|  | int | maxLayers = -1,
|  | bool | ignoreHs = true )

Compute the shape tversky index between two molecule based on a predefined alignment

Parameters

  mol1 | The first molecule of interest
  mol2 | The second molecule of interest
  alpha |
  beta |
  confId1 | Conformer in the first molecule (defaults to first conformer)
  confId2 | Conformer in the second molecule (defaults to first conformer)
  gridSpacing | resolution of the grid used to encode the molecular shapes
  bitsPerPoint | number of bit used to encode the occupancy at each grid point defaults to two bits per grid point
  vdwScale | Scaling factor for the radius of the atoms to determine the base radius used in the encoding - grid points inside this sphere carry the maximum occupancy
  stepSize | thickness of the each layer outside the base radius, the occupancy value is decreased from layer to layer from the maximum value
  maxLayers | the maximum number of layers - defaults to the number allowed the number of bits use per grid point - e.g. two bits per grid point will allow 3 layers
  ignoreHs | if true, ignore the hydrogen atoms in the shape encoding process

References RDKIT_SHAPEHELPERS_EXPORT, and RDKit::DiscreteValueVect::TWOBITVALUE.